<template>
  <div>
    <div class="alert alert-info" role="alert">
      Subscribe to the
      <a href="https://about.gitlab.com/breaking-changes.xml"
        >breaking changes RSS feed</a
      >
      to get notified about breaking changes. Also check the
      <a href="https://docs.gitlab.com/ee/update/deprecations.html"
        >deprecation</a
      >
      docs.<br />
      Data source for this report are
      <a
        href="https://gitlab.com/gitlab-org/gitlab/-/tree/master/data/deprecations"
        >deprecation files</a
      >.
    </div>
    <csv-download
      class="btn btn-primary float-right mx-2"
      :array="filteredDeprecations"
      download="features_filtered.csv"
    />
    <div v-if="loading">Loading...</div>
    <template v-else>
      <form>
        <div class="form-row">
          <div class="form-group col-md-2">
            <label>Removal after (including)</label>
            <multiselect
              v-model="minRemovalVersion"
              :options="allRemovalVersions"
              :customLabel="renderVersion"
              :allowEmpty="true"
            />
          </div>
          <div class="form-group col-md-2">
            <label>Removal before (including)</label>
            <multiselect
              v-model="maxRemovalVersion"
              :options="allRemovalVersions"
              :customLabel="renderVersion"
              :allowEmpty="true"
            />
          </div>
          <div class="form-group col-md-2">
            <label>Announced in</label>
            <multiselect
              v-model="announcedVersion"
              :options="allAnnouncedVersions"
              :customLabel="renderVersion"
              :allowEmpty="true"
            />
          </div>
          <div class="form-group col-md-2">
            <label>Breaking change</label>
            <multiselect
              v-model="breakingChange"
              :options="breakingChangeOptions"
              :allowEmpty="true"
            />
          </div>
          <div class="form-group col-md-2">
            <label>Stage</label>
            <multiselect
              v-model="deprectationStages"
              :options="allStages"
              :multiple="true"
              :allowEmpty="true"
            />
          </div>
          <div class="form-group col-md-2">
            <label>Impact</label>
            <multiselect
              v-model="deprectationImpacts"
              :options="allImpacts"
              :multiple="true"
              :allowEmpty="true"
            />
          </div>
        </div>
        <div class="form-row">
          <div
            class="form-group col-md-3"
            data-toggle="tooltip"
            data-placement="top"
            title="Search supports regular expressions."
          >
            <label>Fulltext search</label>
            <input
              class="form-control"
              placeholder="Search deprecation name and description"
              v-model="textSearch"
            />
          </div>
          <div class="form-group col-md-3">
            <label>Order By</label><br />
            <div class="btn-group" role="group" aria-label="Basic example">
              <select class="custom-select" v-model="orderKey">
                <option value="removal_milestone">Removal Milestone</option>
                <option value="impact">Impact</option>
              </select>
              <button
                type="button"
                @click="order = order * -1"
                class="btn btn-outline-dark"
              >
                {{ order < 0 ? "Asc" : "Desc" }}
              </button>
            </div>
          </div>
        </div>
      </form>
      <paginated-table
        :items="filteredDeprecations"
        :total-items="deprecations.length"
        :per-page-default="500"
        tableClass="changelogTable"
      >
        <template v-slot:header>
          <tr>
            <th>Removal in</th>
            <th style="width: 50%">Description</th>
            <th>Announced in</th>
            <th>Stage</th>
            <th>Breaking change</th>
            <th>Impact</th>
            <th>Links</th>
          </tr>
        </template>
        <template v-slot:row="{ item: deprecation }">
          <td>{{ renderVersion(deprecation.removal_milestone) }}</td>
          <td>
            <strong><span v-html="deprecation.title"></span></strong
            ><span v-html="deprecation.body"></span>
          </td>
          <td>{{ renderVersion(deprecation.announcement_milestone) }}</td>
          <td>{{ deprecation.stage }}</td>
          <td>{{ deprecation.breaking_change }}</td>
          <td>{{ deprecation.impact }}</td>
          <td>
            <a
              v-if="deprecation.documentation_url"
              :href="deprecation.documentation_url"
              >Documentation </a
            > 
            <a v-if="deprecation.issue_url" :href="deprecation.issue_url"
              >Issue</a
            >
          </td>
        </template>
      </paginated-table>
    </template>
  </div>
</template>
<script>
import Multiselect from "vue-multiselect";
import PaginatedTable from "./components/paginated-table.vue";
import CsvDownload from "./components/csv-download.vue";

const uniqAndSort = (array) => {
  return Array.from(new Set(array)).filter(Boolean).sort();
};

let searchDefaults = {
  order: 1,
  orderKey: "removal_milestone",
  textSearch: "",
  announcedVersion: null,
  removalVersion: null,
  minRemovalVersion: null,
  maxRemovalVersion: null,
  breakingChange: null,
  deprectationStages: [],
  deprectationImpacts: [],
};

function eqSet(as, bs) {
  if (as.length !== bs.length) return false;
  for (let a of as) if (!bs.includes(a)) return false;
  return true;
}

function compare_impact(a, b) {
  const impact_map = {"unspecified": 0, "none": 0, "small": 1, "low": 1, "medium": 2, "high": 3, "critical": 4};
  var impact_a = null
  var impact_b = null
  if(a === undefined || a === "") {
    impact_a = 0
  } else {
    impact_a = impact_map[a]
  }
  if(b === undefined || b === "") {
    impact_b = 0
  } else {
    impact_b = impact_map[b]
  }
  return impact_b < impact_a;
}

export default {
  components: {
    CsvDownload,
    PaginatedTable,
    Multiselect,
  },
  data() {
    return {
      data: [],
      loading: true,
      ...searchDefaults,
    };
  },
  async mounted() {
    const response = await fetch("./deprecations.json");

    this.data = await response.json();

    const params = new URLSearchParams(window.location.search);

    searchDefaults.minRemovalVersion = this.allRemovalVersions.slice(-1)[0];
    searchDefaults.maxRemovalVersion = this.allRemovalVersions[0];

    this.minRemovalVersion = searchDefaults.minRemovalVersion;
    this.maxRemovalVersion = searchDefaults.maxRemovalVersion;

    Object.entries(searchDefaults).forEach(([key, value]) => {
      if (Array.isArray(value)) {
        const newVal = params.getAll(key);
        if (!eqSet(newVal, value)) {
          this[key] = newVal;
        }
        return;
      }

      const newVal = params.get(key);

      if (newVal && newVal !== value) {
        this[key] = newVal;
      }
    });
    this.$parent.pageView({ page: "deprecations" });
    this.loading = false;
  },
  updated() {
    const params = new URLSearchParams();
    Object.entries(searchDefaults).forEach(([key, value]) => {
      let newVal = this[key];

      if (Array.isArray(value)) {
        if (!eqSet(newVal, value)) {
          newVal.forEach((x) => {
            params.append(key, x);
          });
        }
        return;
      }

      if (newVal && newVal !== value) {
        params.set(key, newVal);
      }

      params.set("tab", "deprecations");
    });
    window.history.replaceState(
      {},
      "",
      window.location.protocol +
        "//" +
        window.location.host +
        window.location.pathname +
        "?" +
        params.toString()
    );
  },
  methods: {
    renderVersion(version) {
      return version.replace(/\.0?/, ".").replace(/^0/, "");
    },
  },
  computed: {
    allAnnouncedVersions() {
      return uniqAndSort(
        this.deprecations
          .map((deprecation) => deprecation.announcement_milestone)
          .flat()
      ).reverse();
    },
    allRemovalVersions() {
      return uniqAndSort(
        this.deprecations
          .map((deprecation) => deprecation.removal_milestone)
          .flat()
      ).reverse();
    },
    allStages() {
      return uniqAndSort(
        this.deprecations.map((feature) => feature.stage).flat()
      );
    },
    allImpacts() {
      var impacts = uniqAndSort(
        this.deprecations.map((feature) => feature.impact).flat()
      );
      impacts.sort((a, b) => {
          return (compare_impact(a, b) ? -1 : 1);
        });
      return impacts
    },
    breakingChangeOptions() {
      return ["True", "False"];
    },
    searchLower() {
      return this.textSearch.toLocaleLowerCase();
    },
    deprecations() {
      // for all deprecations with empty "impact" fields, set "unspecified" as impact
      return this.data.map(deprecation => ({
        ...deprecation,
        impact: deprecation.impact || "unspecified"
      }));
    },
    filteredDeprecations() {
      return this.deprecations
        .filter((deprecation) => {
          let visible = true;

          if (visible && this.announcedVersion) {
            visible =
              visible &&
              deprecation.announcement_milestone === this.announcedVersion;
          }
          if (visible && this.maxRemovalVersion) {
            visible =
              visible &&
              deprecation.removal_milestone <= this.maxRemovalVersion;
          }

          if (visible && this.minRemovalVersion) {
            visible =
              visible &&
              deprecation.removal_milestone >= this.minRemovalVersion;
          }
          if (visible && this.breakingChange) {
            visible =
              visible && deprecation.breaking_change === this.breakingChange;
          }

          if (visible && this.deprectationStages.length) {
            visible =
              visible && this.deprectationStages.includes(deprecation.stage);
          }

          if (visible && this.deprectationImpacts.length) {
            visible =
              visible && this.deprectationImpacts.includes(deprecation.impact);
          }

          if (visible && this.textSearch) {
            visible =
              visible &&
              (deprecation.title
                .toLocaleLowerCase()
                .includes(this.searchLower) ||
                deprecation.body
                  .toLocaleLowerCase()
                  .includes(this.searchLower));
          }

          return visible;
        })
        .sort((a, b) => {
          const valA = a[this.orderKey];
          const valB = b[this.orderKey];
          if (valA === valB) {
            return 0;
          }

          return (compare_impact(valA, valB) ? -1 : 1) * this.order;
        });
    },
  },
};
</script>
